#include<math.h>
#include <float.h>
#include"myservs.h"
#include"belief_propagation_full.h"



void init_matrix_full(double *left, double *right, double *llr,int *index_b, int *index_g, int nN, int N, int K,double max_val_ex)
{
    int i;
      /// initialize the extrinsic information array
      for (i=0; i<nN+N; i++)
      {
	   left[i] = 0.0;
	   right[i] = 0.0;
      }
      /// set intrinsic information in last position of the matrix message
      for (i=0; i<N; i++)
	  {left[nN+i] = llr[i];} ///<- da lasciare senza remap!!!

	  ///sistemo i dati ricevuti per i canali bloccati
       for (i=0; i<N-K; i++)
        {
         right[index_b[i]]= max_val_ex;
        }
        for (i=0; i<K; i++)
        {right[index_g[i]]= 0.0;}
}

/// compute the full joint probability
/// magnitue is the minimum magnitude
///\param a is the first input
///\param b is the recond input
///\return the min-sum result
static double joint_prob(double a, double b)
{
    if(a>=DBL_MAX)
     return b;
    if(b>=DBL_MAX)
     return a;


  return log(1+exp(a+b))-log(exp(a)+exp(b));
}


/// Backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
void left_message_full(double *left, const double *right, int **dst, int n, int N)
{
  int i,j,k;
  double a;
  double b;
  double r1;
  double r2;

  for (i=n-1; i>=0; i--)
  {
    k = i*N;
    for (j=0; j<N; j+=2)
    {
      /// CHECK NODE
      /// get messages
      a = left[dst[k+N][0]];
      b = left[dst[k+N][1]] + right[dst[k+1+N][1]-N];
      /// compute min sum
      r1 = joint_prob(a, b);

      /// VARIABLE NODE
      a = left[dst[k+1+N][0]];
      b = right[dst[k+N][0]-N];
      /// compute min sum
      r2 = joint_prob(a, b);
      r2 += left[dst[k+1+N][1]]; /// add the left value of second next node destination to Min Sum

      /// save output values
      left[dst[k+N][0]-N] = r1;   /// L(i,j)
      left[dst[k+N+1][1]-N] = r2; /// L(i,j+Ni)

      //printf("%d %d %d %d %d %d\n", k, k+1, dst[k][0], dst[k][1], dst[k+1][0], dst[k+1][1]);

      k += 2;

    }
  }
}

/// Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void right_message_full(const double *left, double *right, int **dst, int n, int N)
{
  int i,j,k;
  double a;
  double b;
  double r1;
  double r2;

  for (i=0; i<n; i++)
  {
    k = i*N;
    for (j=0; j<N; j+=2)
    {
      /// CHECK NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+1+N][1]] + right[dst[k+1+N][1]];
      /// min sum
      r1 = joint_prob(a, b);

      /// VARIABLE NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+N][0]];
      r2 = joint_prob(a, b);
      r2 += right[dst[k+1+N][1]-N];//add the right value of next node to min sum


      right[dst[k+N][0]] = r1; /// R(i+1,j)
      right[dst[k+N][1]] = r2; /// R(i+1,j+N)

      //      printf("%d %d %d %d\n", k, k+1, dst[k][0], dst[k][1]);

      k += 2;
    }
  }
}
