#ifndef _BELIEF_PROPAGATION_FULL_V2_H
#define _BELIEF_PROPAGATION_FULL_V2_H




/// Backward and Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
void left_right_message_full2_dx(double *left, double *right, int **dst, int n, int N);

/// Backward and Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_right_message_full2_sx(double *left, double *right, int **dst, int n, int N);

/// matrices initialization
///\param *left is the left message array
///\param *right is the right message array
///\param *llr is log likelihood ratios from the channel
///\param *index_b is the list of bad channels
///\param *index_g is the list of good channels
///\param nN is log(N)*N
///\param N is the coded size
///\param K is the uncoded size
///\param max_val_ex is the maximum value for the extrinsic information
void init_matrix_full2(double *left, double *right, double *llr,int *index_b, int *index_g, int nN, int N, int K,double max_val_ex);


#endif
