#include<math.h>
#include <float.h>
#include"myservs.h"
#include"belief_propagation_generic.h"
#include"belief_propagation_reduced.h"
#include"myretcodes.h"
#include"myservs.h"

///somma con correzione per overflow/underflow
#ifndef FLOAT

static int sum(int a, int b)
{
  register int res;

  res=a+b;
  if((a>0)&&(res<0)&&(b>0))
    return MAX_INT;
  if((a<0)&&(res>0)&&(b<0))
    return MIN_INT;

  return res;
}

#endif // FLOAT

/// compute the minimum as in LDCP min-sum algorithm:
/// sign is the product of signs
/// magnitue is the minimum magnitude
///\param a is the first input
///\param b is the recond input
///\param s is the scaling factor
///\return the min-sum result
/*static int min_sum(int a, int b, float s)
{
  register int sa, sb;
  register int ma, mb;
  register int d;
  register int sm;
  register int m;

  /// get the signs
  sa = MY_INT_SIGN(a);
  sb = MY_INT_SIGN(b);
  /// compute result sign
  sm = sa ^ sb;
  /// get magnitudes
  ma = sa ^ a;
  ma += sa & 0x1;
  mb = sb ^ b;
  mb += sb & 0x1;
  /// find the min
  d = ma - mb;
  m = (d >= 0) ? mb : ma;
  /// apply the sign
  m ^= sm;
  m += sm & 0x1;
  /// apply scaling
  m = (int)floor(s * m + 0.5);

  return m;
}*/
/*static int min_sum(int a, int b, float s)
{
    register int sa, sb;
    register int ma, mb;
    register int sm;
    register int m;

    register float temp, resto;

    /// get the signs 1-> + ; -1-> -
    sa = MY_INT_SIGN(a);
    sb = MY_INT_SIGN(b);
    sa = sa | 0x1;
    sb = sb | 0x1;
    /// compute result sign
    sm = sa*sb;

    /// get magnitudes
    ma=a*sa;
    mb=b*sb;

    if(a==MIN_INT)
        ma=MAX_INT;
    if(b==MIN_INT)
        mb=MAX_INT;

    /// find the min
    m = (ma > mb) ? mb : ma;

    //if((m==MIN_INT)&&(sm==-1))
    //    return MAX_INT;

    m=sm*m;
    ///
    temp=(s*m);
    resto=temp-trunc(temp);

	if(temp>=0.0)
	{
		if(resto>=0.5)
		{temp=ceil(temp);}
		else
		{temp=floor(temp);}

	}
	else
	{
		if(resto<-0.5)
		{temp=floor(temp);}
		else
		{temp=ceil(temp);}
	}

    m=(int)temp;
    ///
    return m;
}*/

#ifdef FLOAT
static double min_sum(double a, double b, float s)
{
    int sm;
    double ma, mb;
    double m;
    double sms;
    unsigned char sa, sb;

    /// get the signs 1-> + ; -1-> -
    sa = a < 0;
    sb = b < 0;
    /// compute result sign
    sm = sa^sb;

    /// get magnitudes
    ma= fabs(a);
    mb= fabs(b);
    sms = (sm == 0) ? s : -s;
    /// find the min
    m = (ma > mb) ? mb : ma;

    return (m*sms);
}
#else
static int min_sum(int a, int b, float s)
{
    register int sa, sb;
    register int ma, mb;
    register int sm;
    register int m;

    register float temp;

    /// get the signs 1-> + ; -1-> -
    sa = MY_INT_SIGN(a);
    sb = MY_INT_SIGN(b);
    sa = sa | 0x1;
    sb = sb | 0x1;
    /// compute result sign
    sm = sa*sb;

    /// get magnitudes
    ma=a*sa;
    mb=b*sb;

    if(a==MIN_INT)
        ma=MAX_INT;
    if(b==MIN_INT)
        mb=MAX_INT;

    /// find the min
    m = (ma > mb) ? mb : ma;

    //if((m==MIN_INT)&&(sm==-1))
    //    return MAX_INT;

    m=sm*m;
    ///
    temp=(s*m);

    temp=round(temp);

    m=(int)temp;
    ///
    return m;
}
#endif // FLOAT

static int clip(int a,int min_val_ex, int max_val_ex)
{
    if(a>max_val_ex)
        return max_val_ex;
    if(a<min_val_ex)
        return min_val_ex;

    return a;
}

void delete_mem(int *left_temp,int n, int N)
{int i;
      for(i=0;i<(n+1)*N;i++)
      {
        left_temp[i]=0;
      }
}

#ifdef FLOAT
void copy_mem(double *left_temp,double *left,int n, int N)
#else
void copy_mem(int *left_temp,int *left,int n, int N)
#endif // FLOAT
{int i;
      for(i=0;i<(n+1)*N;i++)
      {
        left_temp[i]=left[i];
      }
}


/// Forward and backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
#ifdef FLOAT
void left_right_message_ms_generic(double *left, double *right, double *temp, generic_f point_generic , int n, int N, int min_val_ex, int max_val_ex, float sfact, int *opcount)
#else
void left_right_message_ms_generic(int *left, int *right, int *temp, generic_f point_generic , int n, int N, int min_val_ex, int max_val_ex, float sfact, int *opcount)
#endif // FLOAT
{
  int i,j,k;
  int m,o,p;
  #ifdef FLOAT
  double a;
  double b;
  double r1;
  double r2;
  #else
  int a;
  int b;
  int r1;
  int r2;
  #endif //FLOAT


  copy_mem(point_generic.left_temp,left,n,N);
  copy_mem(point_generic.right_temp,right,n,N);

  for (i=0; i<point_generic.tot; i++)
  {
    /// CONTROLLO DI SICUREZZA
        if((point_generic.vettore_col[i]>=n)||(point_generic.vettore_col[i]<0))
            exit(KO_ADDRESS_COL_UNCORRECT);
    ///
    k = point_generic.vettore_col[i]*N;
    sorter(right,point_generic.vettore_col[i],N,temp);
    for (j=0; j<N; j+=2)
    {
     /// CHECK NODE
     if(point_generic.calc_left[i]==1)
     {
      *opcount++;
      /// get messages
      #ifdef FLOAT
	  a = left[k+N];
      b = left[k+N+1]+right[k+1]; /// modifica somma/////////
      r1 = min_sum(a, b, sfact);
	  /// VARIABLE NODE
      a = left[k+N];
      b = right[k];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 = r2 + left[k+1+N];  /// modifica somma/////////
      if(max_val_ex<0)
        r2=round(r2);
      if(max_val_ex<0)
        r1=round(r1);
	  /// save output values
      point_generic.left_temp[k] = r1;   /// L(i,j)
      point_generic.left_temp[k+1] = r2; /// L(i,j+Ni)
	  #else
	  a = left[k+N];
      b = sum(left[k+N+1],right[k+1]); /// modifica somma/////////
      b=clip(b, min_val_ex, max_val_ex);
	  r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);
	  /// VARIABLE NODE
      a = left[k+N];
      b = right[k];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 = sum(r2, left[k+1+N]);  /// modifica somma/////////
      ///r2 += left[k+1+N]; /// add the left value of second next node destination to Min Sum
      r2=clip(r2, min_val_ex, max_val_ex);
	  /// save output values
      point_generic.left_temp[k] = r1;   /// L(i,j)
      point_generic.left_temp[k+1] = r2; /// L(i,j+Ni)
	  #endif
     }

     /// CHECK NODE
     if(point_generic.calc_right[i]==1)
     {
      *opcount++;
	  #ifdef FLOAT
	  /// get messages
      a = right[k];
      b = left[k+1+N] + right[k+1]; /// modifica somma/////////
      ///b = left[k+1+N] + right[k+1];
      /// min sum
      r1 = min_sum(a, b, sfact);
      /// VARIABLE NODE
      /// get messages
      a = right[k];
      b = left[k+N];
      r2 = min_sum(a, b, sfact);
      r2 = r2 + right[k+1];    /// modifica somma/////////
      ///r2 += right[k+1];//add the right value of next node to min sum
      if(max_val_ex<0)
        r1=round(r1);
      if(max_val_ex<0)
        r2=round(r2);
      point_generic.right_temp[k+N] = r1; /// R(i+1,j)
      point_generic.right_temp[k+N+1] = r2; /// R(i+1,j+N)
	  #else
	  /// get messages
      a = right[k];
      b = sum(left[k+1+N], right[k+1]); /// modifica somma/////////
      ///b = left[k+1+N] + right[k+1];
      b=clip(b, min_val_ex, max_val_ex);
      /// min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      /// get messages
      a = right[k];
      b = left[k+N];
      r2 = min_sum(a, b, sfact);
      r2 = sum(r2,right[k+1]);    /// modifica somma/////////
      ///r2 += right[k+1];//add the right value of next node to min sum
      r2=clip(r2, min_val_ex, max_val_ex);

      point_generic.right_temp[k+N] = r1; /// R(i+1,j)
      point_generic.right_temp[k+N+1] = r2; /// R(i+1,j+N)
	  #endif

     }

     k += 2;
    }
    backsorter(right,point_generic.vettore_col[i],N,temp);
    if(point_generic.calc_left[i]==1)
     {backsorter(point_generic.left_temp,point_generic.vettore_col[i],N,temp);}

    if(point_generic.vettore_upd[i])
    {
       copy_mem(left,point_generic.left_temp,n,N);
       copy_mem(right,point_generic.right_temp,n,N);
    }
    /*
    for(m=0;m<n;m++){
        for(o=0;o<N;o++)
        printf("%d ",left[m*N+o]);
        printf("\n");
        getchar();
    }
    printf("\n\n");
    */
  }


}


void ord_circolare(generic_f *generico, int n, int N)
{int i,j,p;
    printf("Circolare LRL\n");
    (*generico).tot=2*n-2;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   j=0;p=0;
   for(i=0;i<(*generico).tot;i++)
        {
            if(i<n)
              {(*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              j++;
              }
            else
              {
                    if(p==0)
                    {j=j-2;
                     p=1;
                    }
              (*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              j--;
              }
        }

}


void ord_bi_wave(generic_f *generico, int n, int N)
{int i,j,p,k;
    printf("BiWave\n");
    if((n%2)==0)
    {
      (*generico).tot=2*n-2;
    }
    else
    {
       (*generico).tot=2*n-1-2;
    }

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }


   j=0;p=n-1;k=0;
   for(i=0;i<2*n-2;i=i+2)
        {
            if(p==j)
            {
             (*generico).vettore_col[k]=j;
             (*generico).vettore_upd[k]=1;
             k++;
            }
            else
            {
           (*generico).vettore_col[k]=j;
           (*generico).vettore_col[k+1]=p;
           (*generico).vettore_upd[k]=0;
           (*generico).vettore_upd[k+1]=1;
           k=k+2;
            }
           j++;
           p--;
        }
}

void ord_all_on(generic_f *generico, int n, int N)
{int i;
    printf("AllOn\n");
    (*generico).tot=n;


    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_all_on");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_all_on");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_all_on");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_all_on");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   for(i=0;i<n;i++)
        {
            (*generico).vettore_col[i]=i;
            (*generico).vettore_upd[i]=0;
        }
      (*generico).vettore_upd[n-1]=1;
}

void ord_stepped(generic_f *generico, int n, int N)
{int i;
    printf("Stepped\n");
    (*generico).tot=n;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_stepped");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_stepped");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_stepped");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_stepped");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   if((n%2)==0)
      {
          for(i=0;i<(n/2);i++)
            {
                (*generico).vettore_col[i]=2*i;
                (*generico).vettore_upd[i]=0;
                (*generico).vettore_col[i+(n/2)]=2*i+1;
                (*generico).vettore_upd[i+(n/2)]=0;
            }
         (*generico).vettore_upd[(n/2)-1]=1;
         (*generico).vettore_upd[n-1]=1;
      }
   else
      {
        for(i=0;i<(n/2)+1;i++)
            {
                (*generico).vettore_col[i]=2*i;
                (*generico).vettore_upd[i]=0;
            }
        for(i=(n/2)+1;i<n;i++)
            {
                (*generico).vettore_col[i]=2*(i-(n/2)-1)+1;
                (*generico).vettore_upd[i]=0;
            }
         (*generico).vettore_upd[(n/2)]=1;
         (*generico).vettore_upd[n-1]=1;
      }
}

void ord_lineare(generic_f *generico, int n, int N)
{int i;
    printf("Linear LR\n");
    (*generico).tot=n;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   for(i=0;i<(*generico).tot;i++)
        {
            (*generico).vettore_col[i]=i;
            (*generico).vettore_upd[i]=1;

        }
}

void ord_lineare_RL(generic_f *generico, int n, int N)
{int i;
    printf("Linear RL\n");
    (*generico).tot=n;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_lineare");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   for(i=0;i<(*generico).tot;i++)
        {
            (*generico).vettore_col[i]=(*generico).tot-1-i;
            (*generico).vettore_upd[i]=1;

        }
}

void ord_circolare_RL(generic_f *generico, int n, int N)
{int i,j,p;
    printf("Circular RLR\n");
    (*generico).tot=2*n-2;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    for(i=0;i<(*generico).tot;i++)
        {(*generico).calc_left[i]=1;
         (*generico).calc_right[i]=1;
        }

   j=n-1;p=0;
   for(i=0;i<(*generico).tot;i++)
        {
            if(i<n)
              {(*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              j--;
              }
            else
              {
                    if(p==0)
                    {j=j+2;
                     p=1;
                    }
              (*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              j++;
              }
        }
}

void ord_circolare_RL_single_prop(generic_f *generico, int n, int N)
{int i,j,p;
    printf("Circular RLR single prop\n");
    (*generico).tot=2*n-2;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_circolare_RL");


   j=n-1;p=0;
   for(i=0;i<(*generico).tot;i++)
        {
            if(i<n)
              {(*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              (*generico).calc_left[i]=1;
              (*generico).calc_right[i]=0;

              j--;
              }
            else
              {
                    if(p==0)
                    {j=j+2;
                     p=1;
                    }
              (*generico).vettore_col[i]=j;
              (*generico).vettore_upd[i]=1;
              (*generico).calc_left[i]=0;
              (*generico).calc_right[i]=1;

              j++;
              }
              if((*generico).vettore_col[i]==0){
                    (*generico).calc_left[i]=1;
                    (*generico).calc_right[i]=1;
              }
              if((*generico).vettore_col[i]==n-1){
                    (*generico).calc_left[i]=1;
                    (*generico).calc_right[i]=1;
              }
        }
}

void ord_bi_wave_single_prop(generic_f *generico, int n, int N)
{int i,j,p,k;
    printf("BiWave single prop\n");
    if((n%2)==0)
    {
      (*generico).tot=2*n-2;
    }
    else
    {
       (*generico).tot=2*n-1-2;
    }

    (*generico).tot++;

    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");

   j=0;p=n-1;k=0;
   for(i=0;i<2*n-2;i=i+2)
        {
            if(p==j)
            {
             (*generico).vettore_col[k]=j;
             (*generico).vettore_upd[k]=1;
             (*generico).calc_left[k]=1;
             (*generico).calc_right[k]=1;
             k++;
            }
            else
            {
           (*generico).vettore_col[k]=j;
           (*generico).vettore_col[k+1]=p;
           (*generico).vettore_upd[k]=0;
           (*generico).vettore_upd[k+1]=1;
           (*generico).calc_left[k]=0;
           (*generico).calc_right[k]=1;
           (*generico).calc_left[k+1]=1;
           (*generico).calc_right[k+1]=0;
           k=k+2;
            }
           j++;
           p--;
        }

    //(*generico).calc_left[0]=1;
    (*generico).calc_left[(*generico).tot-1]=1;
    (*generico).calc_right[(*generico).tot-1]=0;
    (*generico).vettore_col[(*generico).tot-1]=0;
    (*generico).vettore_upd[(*generico).tot-1]=1;
}


void ord_tetra_wave_single_prop(generic_f *generico, int n, int N)
{int i,l,r,ml,mr,mlv,mrv;
    printf("TetraWave single prop\n");
    (*generico).tot=(n-1)*4;
    (*generico).vettore_col=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).vettore_upd=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_left=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");
    (*generico).calc_right=(int*) myalloc((*generico).tot, sizeof(int), 1, "bp_generic.c", "ord_bi_wave");

   l=0;
   r=n-1;
   if(((n-1)%2)==1){
        ml=(n-1)/2+1;
   }
   else{
        ml=(n-1)/2;
   }

   mr=(n-1)/2+1;
   mrv=0;
   mlv=0;
   for(i=0;i<(n-1)*4;i=i+4)
        {
            (*generico).vettore_col[i]=l;
            (*generico).vettore_upd[i]=0;
            (*generico).calc_left[i]=0;
            (*generico).calc_right[i]=1;
            l++;
            (*generico).vettore_col[i+1]=r;
            (*generico).vettore_upd[i+1]=0;
            (*generico).calc_left[i+1]=1;
            (*generico).calc_right[i+1]=0;
            r--;
            (*generico).vettore_col[i+2]=ml;
            (*generico).vettore_upd[i+2]=0;
            if(mlv==0){
                (*generico).calc_left[i+2]=0;
                (*generico).calc_right[i+2]=1;
                ml++;
                if(ml==n){
                    ml=n-2;
                    mlv=1;
                }
            }
            else{
                (*generico).calc_left[i+2]=1;
                (*generico).calc_right[i+2]=0;
                ml--;
            }

            (*generico).vettore_col[i+3]=mr;
            (*generico).vettore_upd[i+3]=1;
            if(mrv==0){
                (*generico).calc_left[i+3]=1;
                (*generico).calc_right[i+3]=0;
                mr--;
                if(mr==1){
                    mr=1;
                    mrv=1;
                }
            }
            else{
                (*generico).calc_left[i+3]=0;
                (*generico).calc_right[i+3]=1;
                mr++;
            }
        }

        for(i=0; i<(n-1)*4; i++){
            if((*generico).vettore_col[i]==0||(*generico).vettore_col[i]==n-1){
                (*generico).calc_left[i]=1;
                (*generico).calc_right[i]=1;
            }
        }
}

int op_count(generic_f *generico)
{
int i, count=0;
for(i = 0; i < (*generico).tot; i++){
    if((*generico).calc_left[i] == 1)
        count++;
    if((*generico).calc_right[i] == 1)
        count++;
}

return count;
}
