#ifndef BELIEF_PROPAGATION_GENERIC_H_INCLUDED
#define BELIEF_PROPAGATION_GENERIC_H_INCLUDED
#include <math.h>
/// Backward and Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)



typedef struct generic_fun_struct {int tot;
                                   int *vettore_col;
                                   int *vettore_upd; /// quando aggiornare i risultati da memoria temporanea a memoria finale (simula l'hardware)
                                   int *calc_left;   /// se effettuare la left_prop
                                   int *calc_right;  /// se effettuare la right_prop
                                   #ifdef FLOAT
                                   double *left_temp;
                                   double *right_temp;
                                   #else
                                   int *left_temp;
                                   int *right_temp;
                                   #endif // FLOAT
                                  } generic_f;

#ifdef FLOAT
void left_right_message_ms_generic(double *left, double *right, double *temp, generic_f point_generic , int n, int N, int min_val_ex, int max_val_ex, float sfact, int *opcount);
#else
void left_right_message_ms_generic(int *left, int *right, int *temp, generic_f point_generic , int n, int N, int min_val_ex, int max_val_ex, float sfact, int *opcount);
#endif // FLOAT
void ord_circolare(generic_f *generico, int n, int N); ///funzione che assegna gli spazi in memoria e riempie il parametro generic_f con i valori opportuni
int op_count(generic_f *generico);
void ord_bi_wave(generic_f *generico, int n, int N);
void ord_all_on(generic_f *generico, int n, int N);
void ord_stepped(generic_f *generico, int n, int N);

void ord_lineare(generic_f *generico, int n, int N);
void ord_lineare_RL(generic_f *generico, int n, int N);

void ord_circolare_RL(generic_f *generico, int n, int N);

void ord_bi_wave_single_prop(generic_f *generico, int n, int N);

void ord_circolare_RL_single_prop(generic_f *generico, int n, int N);
void ord_tetra_wave_single_prop(generic_f *generico, int n, int N);
#endif // BELIEF_PROPAGATION_SORTED_H_INCLUDED
