#include<math.h>
#include"myservs.h"
#include"belief_propagation_ms.h"
#include <float.h>

/// vertex assignment
///\param n number of levels
///\param N number of vertex
///\param **dst is the array of destianations
#ifdef FLOAT
void assign_vertex(int n, int N, double **dst)
#else
void assign_vertex(int n, int N, int **dst)
#endif // FLOAT
{
  int l;    /// level
  int N2l;  /// N at level l
  int sl;   /// stages at level l
  int s;    /// stage

  int sN2l; /// s*N2l
  int lslN2l; /// l*sl*N2l
  int offset;

  int N2l2; /// N2l/2
  int l1N; /// (l+1)*N

  int K0; /// l1N+sN2l
  int K1; /// K0+N2l2

  int i;

  /// even: check nodes
  /// odd: variable nodes
  for (l=0; l<n; l++)
  {
    sl = 1 << l;
    N2l = N >> l;
    lslN2l = l*sl*N2l;
    N2l2 = N2l/2;
    l1N = (l+1)*N;
    for (s=0; s<sl; s++)
    {
      sN2l = s*N2l;
      offset = sN2l+lslN2l;
      K0 = l1N+sN2l;
      K1 = K0+N2l2;
      for (i=0; i<N2l; i++)
      {
	dst[i+offset][0] = K0+i/2;
	dst[i+offset][1] = K1+i/2;
      }
    }
  }

  ///traslo di una posizione i dati calcolati
  for (i=(N*n)-1;i>=0; i--)
  {
      dst[i+N][0]=dst[i][0];
      dst[i+N][1]=dst[i][1];
  }
  ///sistemo il livello 0
  for(i=0;i<N;i++)
  {
    dst[i][0]=dst[i][0]-N;
    dst[i][1]=dst[i][1]-N;
  }

}


void get_remap(int *remap, int N)
{
   int temp=0;
   int dim=ceil(log2(N));
   int i ;

   remap[0]=0;

   for(i=1; i<N; i++)
    {
       reverse_int(&temp,dim);
       temp++;
       reverse_int(&temp,dim);
       remap[i]=temp;

    }
}

void reverse_int(int *temp, int dim)
{
    unsigned int a, b, c;
    int j;

    c=(unsigned int) (*temp);
    b=0;
    for(j=0;j<dim;j++)
       {
        a=c&1;
        c=c>>1;
        b=b<<1;
        b=b|a;
       }
    *temp=(int)b;
}

#ifdef FLOAT
void init_matrix_ms(double *left, double *right, double *llr,int *index_b, int *index_g, int nN, int N, int K,int r_init)
#else
void init_matrix_ms(int *left, int *right, int *llr,int *index_b, int *index_g, int nN, int N, int K,int r_init)
#endif // FLOAT
{
    FILE *fp;
    int i;
      /// initialize the extrinsic information array
      for (i=0; i<nN+N; i++)
      {
	   left[i] = 0;
	   right[i] = 0;
      }
      /// set intrinsic information in last position of the matrix message
      for (i=0; i<N; i++)
	  {left[nN+i] = llr[i];} ///<- da lasciare senza remap!!!

	  ///sistemo i dati ricevuti per i canali bloccati
       fp =  fopen("column.txt","w");
	   for (i=0; i<N-K; i++)
        {
         #ifdef FLOAT
         if(r_init <0)
         right[index_b[i]]= DBL_MAX;
         else
         right[index_b[i]]= r_init;
         #else
         right[index_b[i]]= r_init;
         #endif // FLOAT


        }
    for(i=0;i<N;i++)
        fprintf(fp,"%d\n",right[i]);
    fclose(fp);
        for (i=0; i<K; i++)
        {right[index_g[i]]= 0;}
}

/// compute the minimum as in LDCP min-sum algorithm:
/// sign is the product of signs
/// magnitue is the minimum magnitude
///\param a is the first input
///\param b is the recond input
///\param s is the scaling factor
///\return the min-sum result
static int min_sum(int a, int b, float s)
{
  register int sa, sb;
  register int ma, mb;
  register int d;
  register int sm;
  register int m;

  /// get the signs
  sa = MY_INT_SIGN(a);
  sb = MY_INT_SIGN(b);
  /// compute result sign
  sm = sa ^ sb;
  /// get magnitudes
  ma = sa ^ a;
  ma += sa & 0x1;
  mb = sb ^ b;
  mb += sb & 0x1;
  /// find the min
  d = ma - mb;
  m = (d >= 0) ? mb : ma;
  /// apply the sign
  m ^= sm;
  m += sm & 0x1;
  /// apply scaling
  m = (int)floor(s * m + 0.5);

  return m;
}


/// Backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
///void left_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_message_ms(int *left, const int *right, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
{
  int i,j,k;
  int a;
  int b;
  int r1;
  int r2;

  for (i=n-1; i>=0; i--)
  {
    k = i*N;
    for (j=0; j<N; j+=2)
    {
      /// CHECK NODE
      /// get messages
      a = left[dst[k+N][0]];
      b = left[dst[k+N][1]] + right[dst[k+1+N][1]-N];
      /// compute min sum
      r1 = min_sum(a, b, sfact);
      /// saturate
      if (r1 > max_val_ex)
	r1 = max_val_ex;
      else if (r1 < min_val_ex)
	r1 = min_val_ex;
      /// VARIABLE NODE
      a = left[dst[k+1+N][0]];
      b = right[dst[k+N][0]-N];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 += left[dst[k+1+N][1]]; /// add the left value of second next node destination to Min Sum
      /// saturate
      if (r2 > max_val_ex)
	r2 = max_val_ex;
      else if (r2 < min_val_ex)
	r2 = min_val_ex;
      /// save output values
      left[dst[k+N][0]-N] = r1;   /// L(i,j)
      left[dst[k+N+1][1]-N] = r2; /// L(i,j+Ni)

      //printf("%d %d %d %d %d %d\n", k, k+1, dst[k][0], dst[k][1], dst[k+1][0], dst[k+1][1]);

      k += 2;

    }
  }
}

/// Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void right_message_ms(const int *left, int *right, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
{
  int i,j,k;
  int a;
  int b;
  int r1;
  int r2;

  for (i=0; i<n; i++)
  {
    k = i*N;
    for (j=0; j<N; j+=2)
    {
      /// CHECK NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+1+N][1]] + right[dst[k+1+N][1]];
      /// min sum
      r1 = min_sum(a, b, sfact);
      /// saturate
      if (r1 > max_val_ex)
	r1 = max_val_ex;
      else if (r1 < min_val_ex)
	r1 = min_val_ex;
      /// VARIABLE NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+N][0]];
      r2 = min_sum(a, b, sfact);
      r2 += right[dst[k+1+N][1]-N];//add the right value of next node to min sum
      /// satuate
      if (r2 > max_val_ex)
	r2 = max_val_ex;
      else if (2 < min_val_ex)
	r2 = min_val_ex;

      right[dst[k+N][0]] = r1; /// R(i+1,j)
      right[dst[k+N][1]] = r2; /// R(i+1,j+N)

      //      printf("%d %d %d %d\n", k, k+1, dst[k][0], dst[k][1]);

      k += 2;
    }
  }
}
