#include<math.h>
#include <float.h>
#include"myservs.h"
#include"belief_propagation_ms_v2.h"



void init_matrix_ms_v2(int *left, int *right, int *llr,int *index_b, int *index_g, int nN, int N, int K,int max_val_ex)
{
    int i;
      /// initialize the extrinsic information array
      for (i=0; i<nN+N; i++)
      {
	   left[i] = 0;
	   right[i] = 0;
      }
      /// set intrinsic information in last position of the matrix message
      for (i=0; i<N; i++)
	  {left[nN+i] = llr[i];} ///<- da lasciare senza remap!!!

	  ///sistemo i dati ricevuti per i canali bloccati
       for (i=0; i<N-K; i++)
        {
         right[index_b[i]]= max_val_ex;
        }
        for (i=0; i<K; i++)
        {right[index_g[i]]= 0;}
}

/// compute the minimum as in LDCP min-sum algorithm:
/// sign is the product of signs
/// magnitue is the minimum magnitude
///\param a is the first input
///\param b is the recond input
///\param s is the scaling factor
///\return the min-sum result
static int min_sum(int a, int b, float s)
{
  register int sa, sb;
  register int ma, mb;
  register int d;
  register int sm;
  register int m;

  /// get the signs
  sa = MY_INT_SIGN(a);
  sb = MY_INT_SIGN(b);
  /// compute result sign
  sm = sa ^ sb;
  /// get magnitudes
  ma = sa ^ a;
  ma += sa & 0x1;
  mb = sb ^ b;
  mb += sb & 0x1;
  /// find the min
  d = ma - mb;
  m = (d >= 0) ? mb : ma;
  /// apply the sign
  m ^= sm;
  m += sm & 0x1;
  /// apply scaling
  m = (int)floor(s * m + 0.5);

  return m;
}


static int clip(int a,int min_val_ex, int max_val_ex)
{
    if(a>max_val_ex)
        return max_val_ex;
    if(a<min_val_ex)
        return min_val_ex;

    return a;
}


/// Forward and backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_right_message_ms_sx_v2(int *left, int *right, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
{
  int i,j,k;
  int a;
  int b;
  int r1;
  int r2;

  for (i=0; i<n; i++)
  {
    k = i*N;
    for (j=0; j<N; j+=2)
    {
     /// CHECK NODE
      /// get messages
      a = left[dst[k+N][0]];
      b = left[dst[k+N][1]] + right[dst[k+1+N][1]-N];
      b=clip(b, min_val_ex, max_val_ex);
      /// compute min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      a = left[dst[k+1+N][0]];
      b = right[dst[k+N][0]-N];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 += left[dst[k+1+N][1]]; /// add the left value of second next node destination to Min Sum
      r2=clip(r2, min_val_ex, max_val_ex);

      /// save output values
      left[dst[k+N][0]-N] = r1;   /// L(i,j)
      left[dst[k+N+1][1]-N] = r2; /// L(i,j+Ni)

      //printf("%d %d %d %d %d %d\n", k, k+1, dst[k][0], dst[k][1], dst[k+1][0], dst[k+1][1]);

      /// CHECK NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+1+N][1]] + right[dst[k+1+N][1]-N];
      b=clip(b, min_val_ex, max_val_ex);
      /// min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      /// get messages
      a = right[dst[k+N][0]-N];
      b = left[dst[k+N][0]];
      r2 = min_sum(a, b, sfact);
      r2 += right[dst[k+1+N][1]-N];//add the right value of next node to min sum
      r2=clip(r2, min_val_ex, max_val_ex);

      right[dst[k+N][0]] = r1; /// R(i+1,j)
      right[dst[k+N][1]] = r2; /// R(i+1,j+N)


      k += 2;
    }
  }
}
