#include<math.h>
#include <float.h>
#include"myservs.h"
#include"belief_propagation_reduced.h"



void init_matrix_ms_reduced(int *left, int *right, int *llr,int *index_b, int *index_g, int nN, int N, int K,int max_val_ex)
{
    int i;
      /// initialize the extrinsic information array
      for (i=0; i<nN+N; i++)
      {
	   left[i] = 0;
      }
      for(i=0; i<2*N; i++)
      {
          right[i] = 0;
      }
      /// set intrinsic information in last position of the matrix message
      for (i=0; i<N; i++)
	  {left[nN+i] = llr[i];} ///<- da lasciare senza remap!!!

	  ///sistemo i dati ricevuti per i canali bloccati
       for (i=0; i<N-K; i++)
        {
         right[index_b[i]]= max_val_ex;
        }
        for (i=0; i<K; i++)
        {right[index_g[i]]= 0;}
}

/// compute the minimum as in LDCP min-sum algorithm:
/// sign is the product of signs
/// magnitue is the minimum magnitude
///\param a is the first input
///\param b is the second input
///\param s is the scaling factor
///\return the min-sum result
static int min_sum(int a, int b, float s)
{
  register int sa, sb;
  register int ma, mb;
  register int d;
  register int sm;
  register int m;

  /// get the signs
  sa = MY_INT_SIGN(a);
  sb = MY_INT_SIGN(b);
  /// compute result sign
  sm = sa ^ sb;
  /// get magnitudes
  ma = sa ^ a;
  ma += sa & 0x1;
  mb = sb ^ b;
  mb += sb & 0x1;
  /// find the min
  d = ma - mb;
  m = (d >= 0) ? mb : ma;
  /// apply the sign
  m ^= sm;
  m += sm & 0x1;
  /// apply scaling
  m = (int)floor(s * m + 0.5);

  return m;
}


static int clip(int a,int min_val_ex, int max_val_ex)
{
    if(a>max_val_ex)
        return max_val_ex;
    if(a<min_val_ex)
        return min_val_ex;

    return a;
}

#ifdef FLOAT
void sorter(double *right, int column,int N, double *temp)
#else
void sorter(int *right, int column,int N, int *temp)
#endif
{int i;
 int start;

 ///temp=(int*) myalloc(N, sizeof(int), 1, "bp_reduced", "sorter");

 start=N*column;
    for(i=0; i<N/2; i++)
    {
        temp[2*i]=right[start+i];
        temp[2*i+1]=right[start+i+(N/2)];
    }

    for(i=0; i<N; i++)
    {right[start+i]=temp[i];
    }

}

#ifdef FLOAT
void backsorter(double *left, int column,int N, double *temp)
#else
void backsorter(int *left, int column,int N, int *temp)
#endif // FLOAT
{int i;
 int start;

 ///temp=(int*) myalloc(N, sizeof(int), 1, "bp_reduced", "sorter");

 start=N*column;
    for(i=0; i<N/2; i++)
    {
        temp[i]=left[start+2*i];
        temp[i+(N/2)]=left[start+2*i+1];
    }

    for(i=0; i<N; i++)
    {left[start+i]=temp[i];
    }

}

/// Forward and backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)

void left_right_message_ms_reduced(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact)
#ifndef FLOAT
{
  int i,j,k,l,m;
  int a;
  int b;
  int r1;
  int r2;

  for (i=0; i<n; i++)
  {
    k = i*N;
    backsorter(left,i+1,N,temp);
    for (j=0; j<N; j+=2)
    {
      if(k<N)
        {l=k;m=1;}
       else
        {l=(k%N)+N;m=0;}

     /// CHECK NODE
      /// get messages
      a = left[k+N];
      b = left[k+N+1] + right[l+1];
      b=clip(b, min_val_ex, max_val_ex);
      /// compute min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      a = left[k+N];
      b = right[l];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 += left[k+N+1]; /// add the left value of second next node destination to Min Sum
      r2=clip(r2, min_val_ex, max_val_ex);

      /// save output values
      left[k] = r1;   /// L(i,j)
      left[k+1] = r2; /// L(i,j+Ni)

      //printf("%d %d %d %d %d %d\n", k, k+1, dst[k][0], dst[k][1], dst[k+1][0], dst[k+1][1]);

      /// CHECK NODE
      /// get messages
      a = right[l];
      b = left[k+N+1] + right[l+1];
      b=clip(b, min_val_ex, max_val_ex);
      /// min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      /// get messages
      a = right[l];
      b = left[k+N];
      r2 = min_sum(a, b, sfact);
      r2 += right[l+1];//add the right value of next node to min sum
      r2=clip(r2, min_val_ex, max_val_ex);


      right[l+(m*N)] = r1; /// R(i+1,j)
      right[l+(m*N)+1] = r2; /// R(i+1,j+N)


      k += 2;
    }
    sorter(right,1,N,temp);
    sorter(left,i+1,N,temp);
  }
}
#else
{
    printf("Error float mode non compatible");
    exit(1);
}
#endif // FLOAT

/// Forward and backward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_right_message_ms_reduced2(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact)
#ifndef FLOAT
{
  int i,j,k,l,m;
  int a;
  int b;
  int r1;
  int r2;

  for (i=0; i<n; i++)
  {
    k = i*N;
    if(i==0)
        {m=1;}
    else
        {m=0;}
    sorter(right,(1-m),N,temp);
    for (j=0; j<N; j+=2)
    {
      if(k<N)
        {l=k;}
       else
        {l=(k%N)+N;}

     /// CHECK NODE
      /// get messages
      a = left[k+N];
      b = left[k+N+1] + right[l+1];
      b=clip(b, min_val_ex, max_val_ex);
      /// compute min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      a = left[k+N];
      b = right[l];
      /// compute min sum
      r2 = min_sum(a, b, sfact);
      r2 += left[k+N+1]; /// add the left value of second next node destination to Min Sum
      r2=clip(r2, min_val_ex, max_val_ex);

      /// save output values
      left[k] = r1;   /// L(i,j)
      left[k+1] = r2; /// L(i,j+Ni)

      //printf("%d %d %d %d %d %d\n", k, k+1, dst[k][0], dst[k][1], dst[k+1][0], dst[k+1][1]);

      /// CHECK NODE
      /// get messages
      a = right[l];
      b = left[k+N+1] + right[l+1];
      b=clip(b, min_val_ex, max_val_ex);
      /// min sum
      r1 = min_sum(a, b, sfact);
      r1=clip(r1, min_val_ex, max_val_ex);

      /// VARIABLE NODE
      /// get messages
      a = right[l];
      b = left[k+N];
      r2 = min_sum(a, b, sfact);
      r2 += right[l+1];//add the right value of next node to min sum
      r2=clip(r2, min_val_ex, max_val_ex);


      right[l+(m*N)] = r1; /// R(i+1,j)
      right[l+(m*N)+1] = r2; /// R(i+1,j+N)


      k += 2;
    }
    if(i==0)
    backsorter(right,0,N,temp);
    backsorter(left,i,N,temp);
  }
}
#else
{
    printf("Error float mode non compatible");
    exit(1);
}
#endif // FLOAT
