#ifndef BELIEF_PROPAGATION_REDUCED_H_INCLUDED
#define BELIEF_PROPAGATION_REDUCED_H_INCLUDED

/// Backward and Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_right_message_ms_reduced(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact);

/// matrices initialization
///\param *left is the left message array
///\param *right is the right message array
///\param *llr is log likelihood ratios from the channel
///\param *index_b is the list of bad channels
///\param *index_g is the list of good channels
///\param nN is log(N)*N
///\param N is the coded size
///\param K is the uncoded size
///\param max_val_ex is the maximum value for the extrinsic information
void init_matrix_ms_reduced(int *left, int *right, int *llr,int *index_b, int *index_g, int nN, int N, int K,int max_val_ex);

#ifdef FLOAT
void sorter(double *right, int column,int N, double *temp);
void backsorter(double *left, int column,int N, double *temp);
#else
void sorter(int *right, int column,int N, int *temp);
void backsorter(int *left, int column,int N, int *temp);
#endif // FLOAT
void left_right_message_ms_reduced2(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact);

#endif // BELIEF_PROPAGATION_REDUCED_H_INCLUDED
