#ifndef BELIEF_PROPAGATION_SORTED_H_INCLUDED
#define BELIEF_PROPAGATION_SORTED_H_INCLUDED

/// Backward and Forward message computation
///\param *left is the left message array
///\param *right is the right message array
///\param **dst is the destination array
///\param n=log2(N)
///\param N is the coded size
///\param min_val_ex is the minimum value for the extrinsic information
///\param max_val_ex is the maximum value for the extrinsic information
///\param sfact is the scaling factor to implement normalized min sum
//void right_message(int **msg, int **dst, int n, int N, int min_val_ex, int max_val_ex, float sfact)
void left_right_message_ms_sorted(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact);

void left_right_message_ms_sorted2(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact);

void left_right_message_ms_sorted3(int *left, int *right, int *temp, int n, int N, int min_val_ex, int max_val_ex, float sfact);

#endif // BELIEF_PROPAGATION_SORTED_H_INCLUDED
