#include"myservs.h"
#include"channels.h"
#include <string.h>
//#include <unistd.h>
#include "belief_propagation_ms.h"

//void reverse_int(int *temp, int dim)
//{
//    unsigned int a, b, c;
//    int j;
//
//    c=(unsigned int) (*temp);
//    b=0;
//    for(j=0;j<dim;j++)
//       {
//        a=c&1;
//        c=c>>1;
//        b=b<<1;
//        b=b|a;
//       }
//    *temp=(int)b;
//}
//
//void get_remap(int *remap, int N)
//{
//   int temp=0;
//   int dim=ceil(log2(N));
//   int i ;
//
//   remap[0]=0;
//
//   for(i=1; i<N; i++)
//    {
//       reverse_int(&temp,dim);
//       temp++;
//       reverse_int(&temp,dim);
//       remap[i]=temp;
//
//    }
//}



void load_upperbound(double* z,int N)
{  FILE* fp;
   int i;
   int n;
   int *remap;
   char complete[1024];
   char file_nome[25];
   double tmp;

   remap=(int*) myalloc(N, sizeof(int), 1, "main", "remap");

   n=(int)ceil(log2(N));

   get_remap(remap, N);

   getcwd(complete, sizeof(complete));
   sprintf(file_nome,"/Z/PE_%d_PAM2_L1_0dB.m",n);
   strcat(complete,file_nome);
   fp = myfopen(complete, "r", "load_upperbound");

    fgets(complete,100,fp);
   for (i=0;i<N;i++)
   fscanf(fp,"%lf, %lf;",&(z[remap[i]]), &tmp);

   free(remap);
   return;
}

/// recursive function for Bhattacharyya parameter computation
///\param cnt is the recursion counter
///\param *z is the Bhattacharyya parameter array
///\param N is the array length
static void z_compute(int cnt, double *z, int N)
{
  int i;
  double tmp;

//  if (cnt < N)
//  {
//    for (i=cnt-1; i>0; i--)
//      z[2*i] = z[i];
//
//    for (i=0; i<(2*cnt); i+=2)
//    {
//      tmp = z[i]*z[i];
//      z[i] = 2*z[i] - tmp;
//      z[i+1] = tmp;
//    }
//    cnt *= 2;
//    z_compute(cnt, z, N);
//  }
  if (cnt < N)
  {
    for (i=0; i<(cnt); i++)
    {
      tmp=z[i]*z[i];
      z[i+cnt]=tmp;
      z[i]=2*z[i]-tmp;
    }

    cnt *= 2;
    z_compute(cnt, z, N);
  }

}


/// compute the Bhattacharyya parameter array
///\param *z Bhattacharyya parameter array
///\param N array length
///\param Bhattacharyya parameter array epsilon
static void bhatta_param(double *z, int N, double bhatta_eps)
{
  int cnt;

  /// set first element to epsilon
  z[0] = bhatta_eps;
  /// compute Bhattacharyya parameter array recursively
  cnt = 1;
  z_compute(cnt, z, N);
}

/// gen channels for simulation
///\param *w is the channel array
///\param N is the number of channels
///\param Bhattacharyya parameter epsilon
///\param K is the number of good channels
void get_channels(channel_t *w, int N, double bhatta_eps, int K, int BEC_AWGN, int stopping_rule)
{
  int i;
  //int j,k;
  double *z;
  //double zmin;
    FILE *fp;
  int* indici_g;

  /// allocate Bhattacharyya parameter array
  z = (double*) myalloc(N, sizeof(double), 1, "get_channels", "z");

  switch(BEC_AWGN)
        {case 0 :bhatta_param(z, N, bhatta_eps);
                 break;
         case 1 :load_upperbound(z,N);
                 break;
        }

  /// initialize channels
  for (i=0; i<N; i++)
  {
    w[i].status = 0; /// reset all channels
    w[i].z_param = z[i]; /// set Bhattacharyya parameter
  }

//  /// channel allocation
//  for (i=0; i<K; i++)
//  {
//    zmin = 1.0;
//    k = 0;
//    for (j=0; j<N; j++)
//    {
//      //if the Bhattacharyya parameter is lower than the minimum (and the channel is bad) update the min
//      if ( (w[j].status == 0) && (w[j].z_param < zmin) )
//      {
//	zmin = w[j].z_param;
//	k = j;
//      }
//    }
//    w[k].status = 1;
//  }

 indici_g = (int*) myalloc(N, sizeof(int), 1, "get_channels", "z");
   for (i=0; i<N; i++)
  {indici_g[i]=i;}

fp=fopen("canali.txt","w");
  for(i=0; i<N; i++){
    fprintf(fp,"%d\t\t%e\n",i+1,z[i]);
  }
  fclose(fp);
  int ind_temp;
  double temp;

  ///Aggiunto l'if sulla condizione "stopping_rule" e l'else
  if(stopping_rule==4)
  {
    for(i=0; i<K; i++) indici_g[N-K+i];
  }
  else {
      for (i=N-1; i>0; i--)
      {
          if(z[i]>z[i-1])
          {
           temp=z[i-1];
           z[i-1]=z[i];
           z[i]=temp;

           ind_temp=indici_g[i-1];
           indici_g[i-1]=indici_g[i];
           indici_g[i]=ind_temp;

           i=N;
          }
      }
  }

 for(i=0; i<K; i++)
 {
    w[indici_g[N-1-i]].status=1;
 }
 /*for (i=0; i<N; i++)
    {
            printf("w[%d]= %d\n",i,w[i].status);
    }*/

   ///DEBUG
//  FILE *fp;
//
//  fp = fopen("z_param.txt","w");
//  if (fp == NULL)
//  {
//    printf("Error in z_param");
//    exit(99);
//  }
//  else
//  {
//      for (i=0; i<N; i++)
//      {
//       fprintf(fp, "%d\n", ((w[i].status)==0)?1:0);
//      }
//  }
//  fclose(fp);
  ///DEBUG FINE

  free(z);
  free(indici_g);
}

/// create index arrays for good and bad channels
///\param *w is the channel array
///\param *index_g is the good channel array
///\param *index_b is the bad channel array
///\param N is the number of channles
void index_of_w(channel_t *w, int *index_g, int *index_b, int N)
{
  int i;
  int g,b;

  g = 0;
  b = 0;
  for (i=0; i<N; i++)
  {
    if (w[i].status == 1)
    {
      index_g[g] = i;
      g++;
    }
    else
    {
      index_b[b] = i;
      b++;
    }
  }
}


