#ifndef _CHANNELS_H
#define _CHANNELS_H

/// channel structure
typedef struct channel_struct
	{
	  int status;
	  double z_param;
	}channel_t;

/// get channels for simulation
///\param *w is the channel array
///\param N is the number of channels
///\param Bhattacharyya parameter epsilon
///\param K is the number of good channels
void get_channels(channel_t *w, int N, double bhatta_eps, int K, int BEC_AWGN, int stopping_rule);

/// create index arrays for good and bad channels
///\param *w is the channel array
///\param *index_g is the good channel array
///\param *index_b is the bad channel array
///\param N is the number of channels
void index_of_w(channel_t *w, int *index_g, int *index_b, int N);


#endif
