#ifndef _ENCODER_H
#define _ENCODER_H

/// Create G (generator) matrix
///\param **g is the matrix pointer
///\param n is log2(N)
void create_g(int **G, int n);

/// Transpose G to speed up encoding
///\param **G is the matrix pointer
///\param **Gt is the transposed matrix pointer
///\param N is the matrix size
void transpose_g(int **G, int **Gt, int N);

/// encoding function
///\param *uncoded is the uncoded array
///\param *coded is the coded array
///\param **Gt is the transposed generator matrix
///\param N is the array length
void encode(int *uncoded, int *coded, int **Gt, int N);

/// Create H (generator) matrix
///\param **G is the matrix pointer
///\param **h is the matrix pointer
///\param n is log2(N)
void create_h(int n, int **H);

/// Transpose H to speed up encoding
///\param **H is the matrix pointer
///\param **Ht is the transposed matrix pointer
///\param N is the matrix size
void transpose_h(int **H, int **Ht, int n);

#endif
