#include "modulate.h"

#include <math.h>
#include "random.h"
#include "myservs.h"
#include "myretcodes.h"
///GRAY mapping for QAM
double _Complex QAM_16[16]={    1.0000 + 1.0000 * I,
                               1.0000 + 3.0000*I,
                               1.0000 - 1.0000*I,
                               1.0000 - 3.0000*I,
                               3.0000 + 1.0000*I,
                               3.0000 + 3.0000*I,
                               3.0000 - 1.0000*I,
                               3.0000 - 3.0000*I,
                              -1.0000 + 1.0000*I,
                              -1.0000 + 3.0000*I,
                              -1.0000 - 1.0000*I,
                              -1.0000 - 3.0000*I,
                              -3.0000 + 1.0000*I,
                              -3.0000 + 3.0000*I,
                              -3.0000 - 1.0000*I,
                              -3.0000 - 3.0000*I};

double complex QAM_64[64]={   -7.0000 + 7.0000*I,
                              -7.0000 + 5.0000*I,
                              -7.0000 + 1.0000*I,
                              -7.0000 + 3.0000*I,
                              -7.0000 - 7.0000*I,
                              -7.0000 - 5.0000*I,
                              -7.0000 - 1.0000*I,
                              -7.0000 - 3.0000*I,
                              -5.0000 + 7.0000*I,
                              -5.0000 + 5.0000*I,
                              -5.0000 + 1.0000*I,
                              -5.0000 + 3.0000*I,
                              -5.0000 - 7.0000*I,
                              -5.0000 - 5.0000*I,
                              -5.0000 - 1.0000*I,
                              -5.0000 - 3.0000*I,
                              -1.0000 + 7.0000*I,
                              -1.0000 + 5.0000*I,
                              -1.0000 + 1.0000*I,
                              -1.0000 + 3.0000*I,
                              -1.0000 - 7.0000*I,
                              -1.0000 - 5.0000*I,
                              -1.0000 - 1.0000*I,
                              -1.0000 - 3.0000*I,
                              -3.0000 + 7.0000*I,
                              -3.0000 + 5.0000*I,
                              -3.0000 + 1.0000*I,
                              -3.0000 + 3.0000*I,
                              -3.0000 - 7.0000*I,
                              -3.0000 - 5.0000*I,
                              -3.0000 - 1.0000*I,
                              -3.0000 - 3.0000*I,
                               7.0000 + 7.0000*I,
                               7.0000 + 5.0000*I,
                               7.0000 + 1.0000*I,
                               7.0000 + 3.0000*I,
                               7.0000 - 7.0000*I,
                               7.0000 - 5.0000*I,
                               7.0000 - 1.0000*I,
                               7.0000 - 3.0000*I,
                               5.0000 + 7.0000*I,
                               5.0000 + 5.0000*I,
                               5.0000 + 1.0000*I,
                               5.0000 + 3.0000*I,
                               5.0000 - 7.0000*I,
                               5.0000 - 5.0000*I,
                               5.0000 - 1.0000*I,
                               5.0000 - 3.0000*I,
                               1.0000 + 7.0000*I,
                               1.0000 + 5.0000*I,
                               1.0000 + 1.0000*I,
                               1.0000 + 3.0000*I,
                               1.0000 - 7.0000*I,
                               1.0000 - 5.0000*I,
                               1.0000 - 1.0000*I,
                               1.0000 - 3.0000*I,
                               3.0000 + 7.0000*I,
                               3.0000 + 5.0000*I,
                               3.0000 + 1.0000*I,
                               3.0000 + 3.0000*I,
                               3.0000 - 7.0000*I,
                               3.0000 - 5.0000*I,
                               3.0000 - 1.0000*I,
                               3.0000 - 3.0000*I};

double complex QAM_256[256]={-15.0000 +15.0000*I,
                             -15.0000 +13.0000*I,
                             -15.0000 + 9.0000*I,
                             -15.0000 +11.0000*I,
                             -15.0000 + 1.0000*I,
                             -15.0000 + 3.0000*I,
                             -15.0000 + 7.0000*I,
                             -15.0000 + 5.0000*I,
                             -15.0000 - 1.0000*I,
                             -15.0000 - 3.0000*I,
                             -15.0000 - 7.0000*I,
                             -15.0000 - 5.0000*I,
                             -15.0000 -15.0000*I,
                             -15.0000 -13.0000*I,
                             -15.0000 - 9.0000*I,
                             -15.0000 -11.0000*I,
                             -13.0000 +15.0000*I,
                             -13.0000 +13.0000*I,
                             -13.0000 + 9.0000*I,
                             -13.0000 +11.0000*I,
                             -13.0000 + 1.0000*I,
                             -13.0000 + 3.0000*I,
                             -13.0000 + 7.0000*I,
                             -13.0000 + 5.0000*I,
                             -13.0000 - 1.0000*I,
                             -13.0000 - 3.0000*I,
                             -13.0000 - 7.0000*I,
                             -13.0000 - 5.0000*I,
                             -13.0000 -15.0000*I,
                             -13.0000 -13.0000*I,
                             -13.0000 - 9.0000*I,
                             -13.0000 -11.0000*I,
                              -9.0000 +15.0000*I,
                              -9.0000 +13.0000*I,
                              -9.0000 + 9.0000*I,
                              -9.0000 +11.0000*I,
                              -9.0000 + 1.0000*I,
                              -9.0000 + 3.0000*I,
                              -9.0000 + 7.0000*I,
                              -9.0000 + 5.0000*I,
                              -9.0000 - 1.0000*I,
                              -9.0000 - 3.0000*I,
                              -9.0000 - 7.0000*I,
                              -9.0000 - 5.0000*I,
                              -9.0000 -15.0000*I,
                              -9.0000 -13.0000*I,
                              -9.0000 - 9.0000*I,
                              -9.0000 -11.0000*I,
                             -11.0000 +15.0000*I,
                             -11.0000 +13.0000*I,
                             -11.0000 + 9.0000*I,
                             -11.0000 +11.0000*I,
                             -11.0000 + 1.0000*I,
                             -11.0000 + 3.0000*I,
                             -11.0000 + 7.0000*I,
                             -11.0000 + 5.0000*I,
                             -11.0000 - 1.0000*I,
                             -11.0000 - 3.0000*I,
                             -11.0000 - 7.0000*I,
                             -11.0000 - 5.0000*I,
                             -11.0000 -15.0000*I,
                             -11.0000 -13.0000*I,
                             -11.0000 - 9.0000*I,
                             -11.0000 -11.0000*I,
                              -1.0000 +15.0000*I,
                              -1.0000 +13.0000*I,
                              -1.0000 + 9.0000*I,
                              -1.0000 +11.0000*I,
                              -1.0000 + 1.0000*I,
                              -1.0000 + 3.0000*I,
                              -1.0000 + 7.0000*I,
                              -1.0000 + 5.0000*I,
                              -1.0000 - 1.0000*I,
                              -1.0000 - 3.0000*I,
                              -1.0000 - 7.0000*I,
                              -1.0000 - 5.0000*I,
                              -1.0000 -15.0000*I,
                              -1.0000 -13.0000*I,
                              -1.0000 - 9.0000*I,
                              -1.0000 -11.0000*I,
                              -3.0000 +15.0000*I,
                              -3.0000 +13.0000*I,
                              -3.0000 + 9.0000*I,
                              -3.0000 +11.0000*I,
                              -3.0000 + 1.0000*I,
                              -3.0000 + 3.0000*I,
                              -3.0000 + 7.0000*I,
                              -3.0000 + 5.0000*I,
                              -3.0000 - 1.0000*I,
                              -3.0000 - 3.0000*I,
                              -3.0000 - 7.0000*I,
                              -3.0000 - 5.0000*I,
                              -3.0000 -15.0000*I,
                              -3.0000 -13.0000*I,
                              -3.0000 - 9.0000*I,
                              -3.0000 -11.0000*I,
                              -7.0000 +15.0000*I,
                              -7.0000 +13.0000*I,
                              -7.0000 + 9.0000*I,
                              -7.0000 +11.0000*I,
                              -7.0000 + 1.0000*I,
                              -7.0000 + 3.0000*I,
                              -7.0000 + 7.0000*I,
                              -7.0000 + 5.0000*I,
                              -7.0000 - 1.0000*I,
                              -7.0000 - 3.0000*I,
                              -7.0000 - 7.0000*I,
                              -7.0000 - 5.0000*I,
                              -7.0000 -15.0000*I,
                              -7.0000 -13.0000*I,
                              -7.0000 - 9.0000*I,
                              -7.0000 -11.0000*I,
                              -5.0000 +15.0000*I,
                              -5.0000 +13.0000*I,
                              -5.0000 + 9.0000*I,
                              -5.0000 +11.0000*I,
                              -5.0000 + 1.0000*I,
                              -5.0000 + 3.0000*I,
                              -5.0000 + 7.0000*I,
                              -5.0000 + 5.0000*I,
                              -5.0000 - 1.0000*I,
                              -5.0000 - 3.0000*I,
                              -5.0000 - 7.0000*I,
                              -5.0000 - 5.0000*I,
                              -5.0000 -15.0000*I,
                              -5.0000 -13.0000*I,
                              -5.0000 - 9.0000*I,
                              -5.0000 -11.0000*I,
                               1.0000 +15.0000*I,
                               1.0000 +13.0000*I,
                               1.0000 + 9.0000*I,
                               1.0000 +11.0000*I,
                               1.0000 + 1.0000*I,
                               1.0000 + 3.0000*I,
                               1.0000 + 7.0000*I,
                               1.0000 + 5.0000*I,
                               1.0000 - 1.0000*I,
                               1.0000 - 3.0000*I,
                               1.0000 - 7.0000*I,
                               1.0000 - 5.0000*I,
                               1.0000 -15.0000*I,
                               1.0000 -13.0000*I,
                               1.0000 - 9.0000*I,
                               1.0000 -11.0000*I,
                               3.0000 +15.0000*I,
                               3.0000 +13.0000*I,
                               3.0000 + 9.0000*I,
                               3.0000 +11.0000*I,
                               3.0000 + 1.0000*I,
                               3.0000 + 3.0000*I,
                               3.0000 + 7.0000*I,
                               3.0000 + 5.0000*I,
                               3.0000 - 1.0000*I,
                               3.0000 - 3.0000*I,
                               3.0000 - 7.0000*I,
                               3.0000 - 5.0000*I,
                               3.0000 -15.0000*I,
                               3.0000 -13.0000*I,
                               3.0000 - 9.0000*I,
                               3.0000 -11.0000*I,
                               7.0000 +15.0000*I,
                               7.0000 +13.0000*I,
                               7.0000 + 9.0000*I,
                               7.0000 +11.0000*I,
                               7.0000 + 1.0000*I,
                               7.0000 + 3.0000*I,
                               7.0000 + 7.0000*I,
                               7.0000 + 5.0000*I,
                               7.0000 - 1.0000*I,
                               7.0000 - 3.0000*I,
                               7.0000 - 7.0000*I,
                               7.0000 - 5.0000*I,
                               7.0000 -15.0000*I,
                               7.0000 -13.0000*I,
                               7.0000 - 9.0000*I,
                               7.0000 -11.0000*I,
                               5.0000 +15.0000*I,
                               5.0000 +13.0000*I,
                               5.0000 + 9.0000*I,
                               5.0000 +11.0000*I,
                               5.0000 + 1.0000*I,
                               5.0000 + 3.0000*I,
                               5.0000 + 7.0000*I,
                               5.0000 + 5.0000*I,
                               5.0000 - 1.0000*I,
                               5.0000 - 3.0000*I,
                               5.0000 - 7.0000*I,
                               5.0000 - 5.0000*I,
                               5.0000 -15.0000*I,
                               5.0000 -13.0000*I,
                               5.0000 - 9.0000*I,
                               5.0000 -11.0000*I,
                              15.0000 +15.0000*I,
                              15.0000 +13.0000*I,
                              15.0000 + 9.0000*I,
                              15.0000 +11.0000*I,
                              15.0000 + 1.0000*I,
                              15.0000 + 3.0000*I,
                              15.0000 + 7.0000*I,
                              15.0000 + 5.0000*I,
                              15.0000 - 1.0000*I,
                              15.0000 - 3.0000*I,
                              15.0000 - 7.0000*I,
                              15.0000 - 5.0000*I,
                              15.0000 -15.0000*I,
                              15.0000 -13.0000*I,
                              15.0000 - 9.0000*I,
                              15.0000 -11.0000*I,
                              13.0000 +15.0000*I,
                              13.0000 +13.0000*I,
                              13.0000 + 9.0000*I,
                              13.0000 +11.0000*I,
                              13.0000 + 1.0000*I,
                              13.0000 + 3.0000*I,
                              13.0000 + 7.0000*I,
                              13.0000 + 5.0000*I,
                              13.0000 - 1.0000*I,
                              13.0000 - 3.0000*I,
                              13.0000 - 7.0000*I,
                              13.0000 - 5.0000*I,
                              13.0000 -15.0000*I,
                              13.0000 -13.0000*I,
                              13.0000 - 9.0000*I,
                              13.0000 -11.0000*I,
                               9.0000 +15.0000*I,
                               9.0000 +13.0000*I,
                               9.0000 + 9.0000*I,
                               9.0000 +11.0000*I,
                               9.0000 + 1.0000*I,
                               9.0000 + 3.0000*I,
                               9.0000 + 7.0000*I,
                               9.0000 + 5.0000*I,
                               9.0000 - 1.0000*I,
                               9.0000 - 3.0000*I,
                               9.0000 - 7.0000*I,
                               9.0000 - 5.0000*I,
                               9.0000 -15.0000*I,
                               9.0000 -13.0000*I,
                               9.0000 - 9.0000*I,
                               9.0000 -11.0000*I,
                              11.0000 +15.0000*I,
                              11.0000 +13.0000*I,
                              11.0000 + 9.0000*I,
                              11.0000 +11.0000*I,
                              11.0000 + 1.0000*I,
                              11.0000 + 3.0000*I,
                              11.0000 + 7.0000*I,
                              11.0000 + 5.0000*I,
                              11.0000 - 1.0000*I,
                              11.0000 - 3.0000*I,
                              11.0000 - 7.0000*I,
                              11.0000 - 5.0000*I,
                              11.0000 -15.0000*I,
                              11.0000 -13.0000*I,
                              11.0000 - 9.0000*I,
                              11.0000 -11.0000*I};

double normalizz_energia_media(double complex *vettore, int n_elem)
{   int i;
    double sq_sum;
    double result;

///    S =S/sqrt( mean( abs(S).^2 ) );

sq_sum=0.0;
for (i=0;i<n_elem;i++)
    {
    sq_sum=sq_sum+pow(cabs(vettore[i]),2);
    }

    result=1.0/sqrt(sq_sum/((double)n_elem));

    return result;
}

/// BICM start //////////////////////////////////////////////////////////////////////
void Interleave (int* input, int* alpha, int InterleaverLength)
{int i,index;
 int* input_temp;

    input_temp=(int*) myalloc(InterleaverLength, sizeof(int), 1, "modulate.c", "Interleave");
    for(i=0;i<InterleaverLength;i++) {
        input_temp[i]=input[i];
    }

    for(i=0;i<InterleaverLength;i++) {
			index = alpha[i];
			input[i] = input_temp[index];
		}
	free(input_temp);
}

void Deinterleave (int* input, int* alpha, int InterleaverLength)
{int i,index;
 int* input_temp;

    input_temp=(int*) myalloc(InterleaverLength, sizeof(int), 1, "modulate.c", "Deinterleave");
    for(i=0;i<InterleaverLength;i++) {
        input_temp[i]=input[i];
    }

    for(i=0;i<InterleaverLength;i++) {
			index = alpha[i];
			input[index] = input_temp[i];
		}
    free(input_temp);
}

int* generateRandomInterleave(int InterleaverLength,random_seed *seed)
{
 int i;
 int* input;
 int* output;

 output=(int*) myalloc(InterleaverLength, sizeof(int), 1, "modulate.c", "generateRandomInterleave");
 input=(int*) myalloc(InterleaverLength, sizeof(int), 0, "modulate.c", "generateRandomInterleave");
 for(i=0;i<InterleaverLength;i++)
    input[i]=i;

 recoursiveInterleave(InterleaverLength,seed,input,output);

 free(input);

 return output;
}

void recoursiveInterleave(int InterleaverLength,random_seed *seed, int* input, int* output )
{int i, index, inter_len;
 //int* input_new;
 double temp;
    if(InterleaverLength==1)
    {
        output[0]=input[0];
        return;
    }
    else
    {
        inter_len= InterleaverLength-1;

        temp=2.0;
        while((temp<-1.0)||(temp>1.0))
              temp=Uniform(seed);


        index=(int)(temp*inter_len+0.5);
        output[inter_len]=input[index];

        for(i=0;i<inter_len;i++)
        {
            if(i<index)
                input[i]=input[i];
            else
               input[i]=input[i+1];
        }

        recoursiveInterleave(inter_len,seed,input,output);
    }
}

/// BICM end ////////////////////////////////////////////////////////////////////////


///SNR
///rate = frame_size/symbols_per_frame
///noise = AWGN noise
///M is the QAM number
void CmlChannel(modulate_data* s)
{double EbNo,EsNo,variance;
 double complex *mod_out;
 double complex *r;
 double complex noise;
 int i;
 double *symbol_likelihood;
 double *bit_likelihood;

     if(s->update_characteristics==1)
     {int temp_int;
      int number_bits=s->frame_size;
      double complex *S;
      double norm;

            /* determine the number of bits per symbol
             for future development: check to make sure M is a power of 2 */
          s->bits_per_symbol = 0;
          temp_int = s->M;
          while (temp_int>1) {
             temp_int = temp_int/2;
             s->bits_per_symbol++;
          }
          /* determine the number of output symbols */
          s->symbols_per_frame = number_bits/s->bits_per_symbol + (number_bits%s->bits_per_symbol>0);
          s->rate=log2(s->M); ///Eb=Es/log2(M)


       switch (s->M)
       {
           case 16:
               S=QAM_16;
           break;
           case 64:
               S=QAM_64;
           break;
           case 256:
               S=QAM_256;
           break;
           default:
           exit(KO_NO_MODULATION);
           return;
       }
       s->constellation=(double complex*) myalloc(s->M, sizeof(double complex), 1, "modulate.c", "CmlChannel");

       norm=normalizz_energia_media(S,s->M);
       for(i=0;i<s->M;i++)
       {
           s->constellation[i]=norm*S[i];
       }

     s->update_characteristics=0;
     }


    EbNo = pow(10,s->SNR/10);
    EsNo = EbNo*s->rate;

    /// determine the noise variance
    variance = 1/(2*EsNo);

    mod_out=modulate(s);

    //a=1.0;
    r=(double complex*) myalloc(s->symbols_per_frame, sizeof(double complex), 1, "modulate.c", "CmlChannel");

    /// Complex modulation
    for(i=0;i<s->symbols_per_frame;i++)
    {
        noise = sqrt(variance)*( Gaussian(s->seed) + Gaussian(s->seed) *I ); /// complex noise
        //r = a.*s + noise;
        r[i]= mod_out[i] + noise;
    }

    symbol_likelihood = Demod2D( r, s, EsNo );
    bit_likelihood = Somap( symbol_likelihood, s );
    free(symbol_likelihood);
    free(r);
    free(mod_out);
    s->output=bit_likelihood;
    return;
}

double complex * modulate (modulate_data* s)
{  int    i,j,index,tmp;
   double complex *S;
   double complex *output;

   S=s->constellation;

   /* create the complex output matrix */
     output=(double complex*) myalloc(s->symbols_per_frame, sizeof(double complex), 1, "modulate.c", "modulate");

  /* determine output */
  for (i=0;i<s->symbols_per_frame;i++)
    { /* create each modulated symbol */
	  index = 0;
	  for (j=0;j<s->bits_per_symbol;j++) { /* go through each associated bit */
		  index = index << 1; /* shift to the left (multiply by 2) */
		  tmp=i*(s->bits_per_symbol)+j;
		  if(tmp<s->frame_size)
		  index += s->input_data[tmp];
		  else
          index += 0;
	  }
	  /* assign the output symbol */
		  output[i] = S[index];
		  //output_i[i] = Si[index];
    }

    return output;
}


double* Demod2D(double complex *r, modulate_data* s,double EsNo)
{int i, j;
 double yr,tempsr,Er;
 double yi,tempsi,Ei;
 double *output;

/* create the complex output matrix */
     output=(double*) myalloc((s->symbols_per_frame * s->M), sizeof(double), 1, "modulate.c", "Demod2D");

    /* determine output */
  for (i=0;i<s->symbols_per_frame;i++)
    { /* go through each received symbol */
	  for (j=0;j<s->M;j++)
        { /* each postulated symbol */
		  tempsr = creal(s->constellation[j]);
		  tempsi = cimag(s->constellation[j]);
		  yr = creal(r[i]);
		  yi = cimag(r[i]);
		  Er = yr - tempsr;
		  Ei = yi - tempsi;
		  output[i*s->M+j] = -EsNo*(Er*Er+Ei*Ei);
	    }
    }
return output;
}

	/* put the different max_star functions into array so easy to call */
	float (*max_star[])(float, float) =
	{
		max_star0, max_star1, max_star2, max_star3, max_star4
	};

double* Somap(double* input, modulate_data* s)
{int n,i,k,mask,m,M;
 double* num;
 double* den;
 double* output_p;
 int NumberSymbols,DataLength;
 int demod_type=4;
 double metric;

    NumberSymbols=s->symbols_per_frame;
    m=s->bits_per_symbol;
    M=s->M;

    DataLength = m*NumberSymbols; /* total number of bits */

    	/* allocate memory */
    den = (double*)	myalloc(m, sizeof(double), 1, "modulate.c", "Somap");
    num = (double*)	myalloc(m, sizeof(double), 1, "modulate.c", "Somap");
 //   llr = (double*)	myalloc(DataLength, sizeof(double), 1, "modulate.c", "Somap"); /* llr input defaults to all-zeros */
    output_p = (double*) myalloc(DataLength, sizeof(double), 1, "modulate.c", "Somap");

    for (n=0;n<NumberSymbols;n++)
        { /* loop over symbols */

		for (k=0;k<m;k++)
            {
			/* initialize */
			num[k] = -1000000;
			den[k] = -1000000;
            }

		for (i=0;i<M;i++)
            {
			metric = input[n*M+i]; /* channel metric for this symbol */

//			mask = 1 << m - 1;
//			for (j=0;j<m;j++)
//                {		/* incorporate extrinsic info */
//				if (mask&i)
//                    {
//					metric += llr[n*m+j];
//                    }
//				mask = mask >> 1;
//                }

			mask = 1 << (m - 1);
			for (k=0;k<m;k++)
                {	/* loop over bits */
				if (mask&i)
                    {
                        /* this bit is a one */
                        //num[k] = ( *max_star[demod_type] )( num[k], metric - llr[n*m+k] );
                        num[k] = ( *max_star[demod_type] )( num[k], metric );
                    }
                else {
                        /* this bit is a zero */
                        den[k] = ( *max_star[demod_type] )( den[k], metric );
                     }
				mask = mask >> 1;
                }
            }

		for (k=0;k<m;k++)
            {
			output_p[m*n+k] = num[k] - den[k];
            }
	}

	free(num);
	free(den);
	//free(llr);
	return output_p;
}
