#ifndef MODULATE_H_INCLUDED
#define MODULATE_H_INCLUDED
#include <complex.h>
#include "random_sel.h"
#include "maxstar.h"

typedef struct modulate_struct {double SNR;
                                int frame_size;             ///equal to # bit
                                int M;                      ///M is the QAM number

                                int update_characteristics; /// se =1 i valori seguenti sono ricalcolati
                                int symbols_per_frame;
                                int bits_per_symbol;
                                double rate;

                                int* input_data;
                                double *output;

                                double complex * constellation;

                                random_seed *seed;
                                } modulate_data;

int* generateRandomInterleave(int InterleaverLength,random_seed *seed);
void recoursiveInterleave(int InterleaverLength,random_seed *seed, int* input, int* output );
void Interleave (int* input, int* alpha, int InterleaverLength);
void Deinterleave (int* input, int* alpha, int InterleaverLength);

void CmlChannel(modulate_data* s);
double complex * modulate (modulate_data* s);
double* Demod2D(double complex *r, modulate_data* s,double EsNo);
double* Somap(double* input, modulate_data* s);

#endif // MODULATE_H_INCLUDED
