#ifndef _MYSERVS_H
#define _MYSERVS_H

#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define MY_INT_SIZE 4
#define MY_INT_SIGN_SHIFT ((MY_INT_SIZE << 3)-1)
#define MY_INT_SIGN(x) (x >> MY_INT_SIGN_SHIFT)


#define MIN_INT (1<<MY_INT_SIGN_SHIFT)
#define MAX_INT (MIN_INT-1)

///#define MY_CLOCK_T_SIZE 4
///#define MY_CLOCK_T_MAX 0xFFFFFFFF

#define MY_CLOCK_T_SIZE 8
#define MY_CLOCK_T_MAX 0xFFFFFFF

#define LARGE_INT_VAL 200

#ifndef log2
#define log2(x) (log((double)x)/log(2.0))
#endif

/// my wrap to fopen with pointer check
///\param *fname is the file name
///\param *mod is the file opening mode "r", "w", ...
///\param *fcaller is a string containing the name of the calling function
FILE* myfopen(char *fname, char *mod, char *fcaller);
/// my wrap to malloc/calloc with pointer check
///\param nelem is the number of element to allocate
///\param nsize is the size of each element
///\param init is a boolean value: 1 memory is initialized to zero; 0 memory is not itialized
///\param *fcaller is a string containing the name of the calling function
///\param *aname is a string containing the name of the array that will get allocation pointer
void* myalloc(int nelem, int nsize, int init, char *fcaller, char *aname);
/// my wrap to fgets with fgets return value check
///\param *buf is the buffer read from file *fp
///\param N is the maximum number of characters read from *fp (including newline)
///\param *fp is the file pointer
///\param *cname is the calling function name
///\param *dstring is a description string
void myfgets(char *buf, int N, FILE *fp, const char *cname, const char *dstring);
/// check the fscanf return value, namely compared val and N
///\param val is the fscanf return value
///\param N is the number of data to read in fscanf
///\param dstring is a description string
void tmp_check(int val, int N, const char *dstring);

#endif
