library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity data_splitter is
    
generic(N: natural :=8);

port(	clk,resetn,sel,ENABLE_S: in std_logic;
      splitter_in: in std_logic;
      xnor_out: out std_logic);
end entity data_splitter;

architecture behavior of data_splitter is 

component demux1to2
	port(
   D : in STD_LOGIC;
   sel: in STD_LOGIC;
   A,B: out STD_LOGIC
   );
end component;

component reg1 is

PORT(
d_r : IN STD_LOGIC;
data_valid : IN STD_LOGIC; -- load/enable.
resetn : IN STD_LOGIC; -- async. clear.
clk : IN STD_LOGIC; -- clock.
q : OUT STD_LOGIC -- output.
);
END component reg1;

signal s_A,s_B,s_q1,s_q2,s_splitter_in: std_logic;
signal s_xnor_out:std_logic;

begin
process(clk,resetn,sel,ENABLE_S)
    begin
    if resetn = '0' then
        s_A <= '0';
        s_B <= '0';
    elsif rising_edge(clk) then
        if ENABLE_S='1' then
            if sel='0' then
                s_A <= splitter_in;
                s_B <= s_B;
            else s_A <= s_A;
                 s_B <= splitter_in;
            end if;
       end if;
    end if;
end process;
xnor_out <= s_q1 and s_q2;
    
DEMUX1: demux1to2 port map(splitter_in,sel,s_A,s_B);
REG_input1: reg1 port map(s_A,ENABLE_S,resetn,clk,s_q1);
REG_input2: reg1 port map(s_B,ENABLE_S,resetn,clk,s_q2);
end behavior;
