library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity data_splitter_array is

generic(N: natural :=8);

port(	clk,resetn,sel,ENABLE_S: in std_logic;
	splitter_inN: in std_logic_vector(N-1 downto 0);
	splitter_outN: out std_logic_vector(N-1 downto 0));
end entity data_splitter_array;

architecture behavior of data_splitter_array is	

component data_splitter
	port(	clk,resetn,sel,ENABLE_S,splitter_in: in std_logic;
      		xnor_out: out std_logic);
end component;

begin
	DATA_SPLITTER_GEN:
   	for I in 0 to N-1 generate
      		DATA_SPLITTER_I : data_splitter port map(clk, resetn, sel, ENABLE_S,splitter_inN(i), splitter_outN(i));
   	end generate DATA_SPLITTER_GEN;
end behavior;
