library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity input_FBER is

generic(N: natural :=8);

port(	clk,resetn,ENABLE_W: in std_logic;
	   L1: in std_logic_vector(N-1 downto 0):=(others=>'0');
	   X1: in std_logic_vector(N-1 downto 0):=(others=>'1');
	   D1: out std_logic_vector(N-1 downto 0));
end entity input_FBER;

architecture behavior of input_FBER is	

component registerN is

port(	clk,resetn,ENABLE_W: IN STD_LOGIC; 
      d  : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
	   q   : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0)
);
end component registerN;

component xorN is
PORT(  D_X   : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
       D_L   : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
       S1   : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0));
end component;

signal data_in_L: std_logic_vector(N-1 downto 0);
signal data_in_X: std_logic_vector(N-1 downto 0);

begin
    
L_reg: registerN port map(
            clk => clk,
            resetn => resetn,
            ENABLE_W => ENABLE_W,
            d => L1,
            q => data_in_L);
X_reg: registerN port map(
            clk => clk,
            resetn => resetn,
            ENABLE_W => ENABLE_W,
            d => X1,
            q => data_in_X);
XOR1: xorN port map(
            D_X => data_in_L,
            D_L => data_in_X,
            S1 => D1);
end behavior;
