library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity output_FBER is

generic(N: natural :=8);

port( clk, resetn, data_valid: in std_logic;
      D3: in std_logic_vector(N-1 downto 0);
      S3: out std_logic);

end entity output_FBER;

architecture behavior of output_FBER is	

component andN is

PORT (x : IN STD_LOGIC_VECTOR(N-1 downto 0);
      f : OUT STD_LOGIC);
END component andN;

component reg1 is

PORT(
d_r : IN STD_LOGIC;
data_valid : IN STD_LOGIC; -- load/enable.
resetn : IN STD_LOGIC; -- async. clear.
clk : IN STD_LOGIC; -- clock.
q : OUT STD_LOGIC -- output.
);
END component reg1;

signal s_input_andN: std_logic_vector(N-1 downto 0);
signal s_output_andN: std_logic;

begin
s_input_andN<=D3;

AND_n: andN port map(D3,s_output_andN);
REG_output: reg1 port map(s_output_andN,data_valid,resetn,clk,S3);

end architecture behavior;
