library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

ENTITY registerN IS 

generic(N: natural :=8);

PORT(
    clk : IN STD_LOGIC; -- clock.
    resetn : IN STD_LOGIC; -- async. clear.
    ENABLE_W  : IN STD_LOGIC; -- load/enable.
    d   : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
    q   : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0) -- output
);
END registerN;

ARCHITECTURE description OF registerN IS

BEGIN
    process(clk, resetn)
    begin
        if resetn = '0' then
            q <= (others=>'0');
        elsif rising_edge(clk) then
            if ENABLE_W= '1' then
                q <= d;
            end if;
        end if;
    end process;
END description;
