library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use STD.textio.all;
use ieee.std_logic_textio.all;

entity testbench is
end entity testbench;

architecture behavior of testbench is

constant N    : integer := 8;

signal hresetn       : std_logic;
signal clk        : std_logic;
signal start, load_new: std_logic;
signal end_of_file,stop : std_logic:='0';
signal st_rest: std_logic;
signal L_in :std_logic_vector(N-1 downto 0);
signal X_in :std_logic_vector(N-1 downto 0);
signal output        : std_logic:='0';

component FBER is 
	generic (N : integer := 8);

	port( clk,hresetn,start,load_new : in std_logic;
		   L,X	: in  std_logic_vector(N-1 downto 0);
		   DONE_FBER, rest, ENABLE_W : out std_logic);
end component;

file file_vectors : text;

begin  -- architecture behavior
  
  reset_process: process is             --Genera un segnale 
  begin                                 --all'inizio dell'esecuizione
    hresetn <= '1';
    wait for 10 ns;
    hresetn <= '0';
    wait for 30 ns;
    hresetn <= '1';
    wait;
  end process reset_process;
  
  clk_process: process is              
  begin  -- process clk_process
    clk <= '0';
    wait for 10 ns;
    clk <= '1';
    wait for 10 ns;
  end process clk_process;
  
  start_process: process is             --Temporizza il segnale 
begin  -- process start_process         di start
start <= '0';
wait for 70 ns;
start <= '1';
wait for 40 ns;
start <= '0';
wait;
end process start_process;

  send_data: process (clk,st_rest) is        --Regola l'invio degli input
    variable v_ILINE     : line;
    variable v_file_L : std_logic_vector(N-1 downto 0);
    variable v_file_X : std_logic_vector(N-1 downto 0);
    variable v_SPACE     : character;
  begin  -- process read_file
      if output='1' then 
      stop<='1';
   end if;
	if (rising_edge(clk) and (st_rest='1' and stop='0')) then
		file_open(file_vectors, "/home/thesis/mattia.marino/Desktop/VHDL/Source_file/coded8.txt",  read_mode);
		if not endfile(file_vectors) then
		    if (st_rest='1' or load_new <='0') then
	      		readline(file_vectors, v_ILINE);
	      		read(v_ILINE, v_file_L);
	      		read(v_ILINE, v_SPACE);           -- read in the space character
			  read(v_ILINE, v_file_X);
			  L_in <= v_file_L;
			  X_in <= v_file_X;
			  end if;
			  load_new <= '1';
	   else
	   end_of_file <= '1';
	   stop<='1';
	   file_close(file_vectors);
	   load_new<='0';
		end if;
	end if;
  end process send_data;
  
 FBER_MAP : FBER port map (
		clk	=> clk,
		hresetn 	=> hresetn,
		start	=> start,
		load_new => load_new,
		L	=> L_in,
		X	=> X_in,
		DONE_FBER => output,
		rest => st_rest);

end architecture behavior;
