library ieee ;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

ENTITY xnorN IS 

generic(N: natural :=8);

PORT(
    clk : IN STD_LOGIC; 
    resetn : IN STD_LOGIC; 
    sel,ENABLE_X,ENABLE_S : IN STD_LOGIC; 
    D2   : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
    S2   : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0)
);
END xnorN;

ARCHITECTURE behavior OF xnorN IS
    
component data_splitter_array
	port(	clk,resetn,sel,ENABLE_S: in std_logic;
	   splitter_inN: in std_logic_vector(N-1 downto 0);
      splitter_outN: out std_logic_vector(N-1 downto 0));
end component;

component registerN is

port(	clk,resetn,ENABLE_W: IN STD_LOGIC; 
      d  : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
	   q   : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0)
);
end component registerN;

signal s_xnor_temp: std_logic_vector(N-1 downto 0);

begin

DATA1: data_splitter_array port map(clk,resetn,sel,ENABLE_S,D2,s_xnor_temp);
REG_XNOR: registerN port map(clk, resetn, ENABLE_X,s_xnor_temp,S2);

end behavior;
